#include        "AvrX.inc"
/*
        Copyright 1999-2000, Larry Barello
        larry@barello.net

*/
;
; AvrX Time Queue Manager
;
/*+
;
;------------------------------------------------
; void AvrXStartTimerMessage(pTimerMessageBlock, uint16_t, pMessageQueue)
;
; PASSED:       R25:R24 = TCB
;               R23:R22 = Timeout
;               R20:R21 = MessageQueue
; Returns:
; Uses:
;-
-*/
        .global AvrXStartTimerMessage
        .func   AvrXStartTimerMessage
AvrXStartTimerMessage:
        subi    R22, lo8(-0)
        sbci    R23, hi8(-0)
        brne    1f
        mov     R22, R24
        mov     R23, R25
        mov     R24, R20
        mov     R25, R21
        rjmp    AvrXSendMessage         ; Count Zero, just queue onto message queue
1:
        mov     Zl, R24
        mov     Zh, R25
        std     Z+TcbQueue, R21
        std     Z+TcbQueue+1, R20       ; Stuff the queue
        ldi     R20, lo8(TIMERMESSAGE_EV)
        ldi     R21, hi8(TIMERMESSAGE_EV)
        std     Z+TcbSemaphore, R21
        std     Z+TcbSemaphore+1, R20   ; Cruft up bogus semaphore
        rjmp    CountNotZero            ; This is in avrx_timequeue.s
        .endfunc

