#include        "AvrX.inc"
/*
        Copyright 1999-2000, Larry Barello
        larry@barello.net

*/
        .section .text.avrx.priority
/*+
; --------------------------------------------------
; uint8_t AvrXChangePriority(pProcessID, uint8_t)
; uint8_t AvrXPriority(void)
; pProcessID AvrXSelf(void)
;
; Routines for manipulating process priorities.  Since GCC is
; inherently little endien and AvrX is big endien, access to
; AvrX data structures is strictly limited to AvrX code.
;
; If I changed AvrX, then many routines could be written in
; C...  Maybe tomorrow
;
; PASSED:       
; RETURNS:      
; USES: 
; CALLS:
; ASSUMES:
; NOTES:        
-*/
        .func   AvrXChangePriority
        .global AvrXChangePriority
AvrXChangePriority:
        mov     Zl, R24
        mov     Zh, R25
        ldd     R24, Z+PidPriority
        std     Z+PidPriority, R23
        ret
        .endfunc
        
        .func   AvrXSelf
        .global AvrXSelf
AvrXSelf:
        lds     R25, RunQueue
        lds     R24, RunQueue+1
        ret
        .endfunc
        
        .func   AvrXPriority
        .global AvrXPriority
AvrXPriority:
        lds     Zh, RunQueue
        lds     Zl, RunQueue+1
        ldd     R24, Z+PidPriority
        ret
        .endfunc

